package xyz.etztech.qol.other;

public class LinkCommand {

    private String command;
    private String url;
    private String message; // Placeholder

    public LinkCommand(String command, String url) {
        this.command = command.toLowerCase();
        this.url = url;
        this.message = "Click here to open the " + command + " link.";
    }

    public String getCommand() {
        return command;
    }

    public void setCommand(String command) {
        this.command = command;
    }

    public String getUrl() {
        return url;
    }

    public void setUrl(String url) {
        this.url = url;
    }

    public String getMessage() {
        return message;
    }

    public void setMessage(String message) {
        this.message = message;
    }

    public static LinkCommand fromString(String raw) {
        String[] parts = raw.split(",");
        if (parts.length != 2) {
            return null;
        }
        return new LinkCommand(parts[0], parts[1]);
    }
}
